## pdal 1.6.0

=== CMakeLists.txt ===
#
# top-level CMake configuration file for PDAL
#
# (based originally on the libLAS files copyright Mateusz Loskot)

cmake_minimum_required(VERSION 2.8.12)

project(PDAL CXX C)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

set(ROOT_DIR "${PROJECT_SOURCE_DIR}")
include(${ROOT_DIR}/cmake/common.cmake NO_POLICY_SCOPE)

#------------------------------------------------------------------------------
# internal cmake settings
#------------------------------------------------------------------------------

set(CMAKE_COLOR_MAKEFILE ON)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
include(FeatureSummary)

# Allow advanced users to generate Makefiles printing detailed commands
mark_as_advanced(CMAKE_VERBOSE_MAKEFILE)

#------------------------------------------------------------------------------
# PDAL general settings
#------------------------------------------------------------------------------

# the next line is the ONLY place in the entire pdal system where
# the version info is hard-coded
set(PDAL_VERSION_STRING "1.6.0" CACHE STRING "PDAL version" FORCE)

DISSECT_VERSION()
GET_OS_INFO()
SET_INSTALL_DIRS()

set(PDAL_API_VERSION "5")
set(PDAL_BUILD_VERSION "6.1.0")

# Name of C++ library

#
# To facilitate one-library linking, we do special things for various platforms.
#
# On Linux we install a linker script that we call libpdalcpp.so and it
# in turn links libpdal_base.so and libpdal_util.so
#
# On OSX we reexport the symbols from libpdal_util.dylib into libpdalcpp.dylib
# See below for the rest of the magic.
#
if (APPLE OR WIN32)
    set(PDAL_LIB_NAME pdalcpp)
    set(PDAL_BASE_LIB_NAME pdalcpp)
else()
    set(PDAL_LIB_NAME pdalcpp)
    set(PDAL_BASE_LIB_NAME pdal_base)
endif()
set(PDAL_UTIL_LIB_NAME pdal_util)
set(PDAL_BOOST_LIB_NAME pdal_boost)
set(PDAL_KAZHDAN_LIB_NAME pdal_kazhdan)

set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

set(PDAL_OUTPUT_LIB_DIR "${PDAL_BINARY_DIR}/${PDAL_LIB_INSTALL_DIR}")
set(PDAL_OUTPUT_BIN_DIR "${PDAL_BINARY_DIR}/${PDAL_BIN_INSTALL_DIR}")

# allow override of PDAL_PLUGIN_INSTALL_PATH path
if (NOT PDAL_PLUGIN_INSTALL_PATH)
    set(PDAL_PLUGIN_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${PDAL_LIB_INSTALL_DIR}")
endif()
file(MAKE_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}")
file(MAKE_DIRECTORY "${PDAL_OUTPUT_BIN_DIR}")

include(${PDAL_CMAKE_DIR}/rpath.cmake)

# wipe lib/ drectory on clean. It will have plugins that could be out of date
# in the next build
set_directory_properties(PROPERTY ADDITIONAL_MAKE_CLEAN_FILES
    "${PDAL_OUTPUT_LIB_DIR}/*")

if(WIN32)
  add_definitions("-DPDAL_DLL_EXPORT=1")
  foreach(config ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER ${config} CONFIG)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CONFIG} "${PDAL_OUTPUT_LIB_DIR}")
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CONFIG} "${PDAL_OUTPUT_BIN_DIR}")
    # ---[ Windows requires DLLs (shared libraries) to be installed in
    # ---[ the same directory as executables
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CONFIG} "${PDAL_OUTPUT_BIN_DIR}")
  endforeach(config)
else(WIN32)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PDAL_OUTPUT_BIN_DIR}")
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}")
endif(WIN32)

# Choose package components

include(${PDAL_CMAKE_DIR}/options.cmake)

#------------------------------------------------------------------------------
# General build settings
#------------------------------------------------------------------------------

set(PDAL_BUILD_TYPE ${CMAKE_BUILD_TYPE})

#------------------------------------------------------------------------------
#  Dependencies.
#------------------------------------------------------------------------------

include(${PDAL_CMAKE_DIR}/gdal.cmake)
include(${PDAL_CMAKE_DIR}/geos.cmake)
include(${PDAL_CMAKE_DIR}/geotiff.cmake)  # Optional (not really)
include(${PDAL_CMAKE_DIR}/lazperf.cmake)  # Optional
include(${PDAL_CMAKE_DIR}/laszip.cmake)  # Optional
include(${PDAL_CMAKE_DIR}/pdaljni.cmake)  # Optional
include(${PDAL_CMAKE_DIR}/threads.cmake)
include(${PDAL_CMAKE_DIR}/zlib.cmake)
include(${PDAL_CMAKE_DIR}/test.cmake)
include(${PDAL_CMAKE_DIR}/ctest.cmake)
include(${PDAL_CMAKE_DIR}/json.cmake)
include(${PDAL_CMAKE_DIR}/libxml2.cmake)
include(${PDAL_CMAKE_DIR}/dimension.cmake)
include(${PDAL_CMAKE_DIR}/python.cmake)
include(${PDAL_CMAKE_DIR}/arbiter.cmake)

#------------------------------------------------------------------------------
# generate the pdal_defines.h header
#------------------------------------------------------------------------------

# from http://stackoverflow.com/questions/1435953/how-can-i-pass-git-sha1-to-compiler-as-definition-using-cmake
include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_SHA1)

configure_file(
  "${PROJECT_SOURCE_DIR}/gitsha.cpp.in"
  "${PROJECT_SOURCE_DIR}/pdal/gitsha.cpp")

# needs to come before configuration of pdal_defines
if(APPLE)
    option(PDAL_BUNDLE "Create PDAL as Application Bundle on OSX" FALSE)
    if (PDAL_BUNDLE)
        set(PDAL_APP_BUNDLE 1)
    endif()
endif()

set(pdal_defines_h_in "${CMAKE_CURRENT_SOURCE_DIR}/pdal_defines.h.in")
set(pdal_defines_h "${CMAKE_CURRENT_BINARY_DIR}/include/pdal/pdal_defines.h")
include(CheckIncludeFiles)
check_include_files(execinfo.h PDAL_HAVE_EXECINFO_H)
configure_file(${pdal_defines_h_in} ${pdal_defines_h})

#------------------------------------------------------------------------------
# subdirectory controls
#------------------------------------------------------------------------------

# PDAL_TARGET_OBJECTS is used to collect the driver object libraries
set(PDAL_TARGET_OBJECTS "")

if (WITH_TESTS)
    enable_testing()
endif()

add_subdirectory(plugins)

#include_directories(vendor/pdalboost)
if (WITH_TESTS)
    include (${PDAL_CMAKE_DIR}/gtest.cmake)
    add_subdirectory(test)
endif()
add_subdirectory(dimbuilder)
add_subdirectory(vendor/pdalboost)
add_subdirectory(vendor/arbiter)
add_subdirectory(vendor/kazhdan)
if (NOT PDAL_HAVE_JSONCPP)
    add_subdirectory(vendor/jsoncpp/dist)
endif()
add_subdirectory(pdal/util)
#add_subdirectory(tools)
add_subdirectory(apps)

#
# On OSX we reexport the symbols in libpdal_util.dylib into libpdalcpp.dylib
# so that users only need link libpdalcpp.
#
if (APPLE)
    set(PDAL_REEXPORT "-Wl,-reexport_library,$<TARGET_FILE:${PDAL_UTIL_LIB_NAME}>")
    #
    # This allows the rpath reference for the reexported library (above) to
    # be found.
    #
    set(PDAL_LIBDIR "-L$<TARGET_FILE_DIR:${PDAL_UTIL_LIB_NAME}>")
endif()

file(GLOB BASE_SRCS
    ${PDAL_FILTERS_DIR}/*.cpp
    ${PDAL_IO_DIR}/*.cpp
    ${PDAL_KERNELS_DIR}/*.cpp
    ${PDAL_SRC_DIR}/*.cpp)
file(GLOB_RECURSE PRIVATE_SRCS
    ${PDAL_FILTERS_DIR}/private/*.cpp
    ${PDAL_IO_DIR}/private/*.cpp
    ${PDAL_KERNELS_DIR}/private/*.cpp
    ${PDAL_SRC_DIR}/private/*.cpp)
list(APPEND SRCS ${BASE_SRCS} ${PRIVATE_SRCS})
if (NOT PDAL_HAVE_LIBXML2)
    file(GLOB XML_SRCS
        io/Ilvis2MetadataReader.cpp
        io/Ilvis2Metadata.cpp
        pdal/DbWriter.cpp
        pdal/DbReader.cpp
        pdal/XMLSchema.cpp)
    list(REMOVE_ITEM SRCS ${XML_SRCS})
endif()
PDAL_ADD_LIBRARY(${PDAL_BASE_LIB_NAME} ${SRCS} ${RPLY_SRCS})

#
# Interface include directories allow downstream project to get the directory
# without specification.
#
target_include_directories(${PDAL_BASE_LIB_NAME}
    PRIVATE
        ${ROOT_DIR}
        ${PROJECT_BINARY_DIR}/include
        ${PDAL_VENDOR_DIR}
        ${PDAL_VENDOR_DIR}/eigen
        ${PDAL_VENDOR_DIR}/pdalboost
        ${PDAL_JSONCPP_INCLUDE_DIR}
        ${LIBXML2_INCLUDE_DIR}
    INTERFACE
        ${GDAL_INCLUDE_DIR}
        ${LASZIP_INCLUDE_DIR}
)
target_link_libraries(${PDAL_BASE_LIB_NAME}
    PUBLIC
        ${CMAKE_THREAD_LIBS_INIT}
        ${GDAL_LIBRARY}
        ${GEOS_LIBRARY}
        ${GEOTIFF_LIBRARY}
        ${LASZIP_LIBRARY}
        ${LIBXML2_LIBRARIES}
        ${ZLIB_LIBRARIES}
        ${CURL_LIBRARIES}
        ${WINSOCK_LIBRARY}
    PRIVATE
        ${PDAL_REEXPORT}
        ${PDAL_UTIL_LIB_NAME}
        ${PDAL_ARBITER_LIB_NAME}
        ${PDAL_KAZHDAN_LIB_NAME}
    ${JSON_CPP_LINK_TYPE}
        ${PDAL_JSONCPP_LIB_NAME}
    INTERFACE
        ${PDAL_LIBDIR}
)
target_compile_definitions(${PDAL_BASE_LIB_NAME}
    PRIVATE
        ${LASZIP_DEFINES}
)
set_target_properties(${PDAL_BASE_LIB_NAME} PROPERTIES
    VERSION ${PDAL_BUILD_VERSION}
    SOVERSION ${PDAL_API_VERSION}
    CLEAN_DIRECT_OUTPUT 1)
#
# On Linux, we install a linker script as libpdalcpp.so.  That file
# specifies linking in libpdal_base.so and libpdal_util.so.  This allows
# users to link a single library, libpdalcpp
#
if (UNIX AND NOT APPLE)
    set(LIBNAME ${CMAKE_SHARED_LIBRARY_PREFIX}${PDAL_LIB_NAME})
    install(FILES ${LIBNAME} DESTINATION ${PDAL_LIB_INSTALL_DIR}
        RENAME ${LIBNAME}${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()

#
# Installation
#
install(DIRECTORY ${PDAL_INCLUDE_DIR}/pdal
    DESTINATION include
    FILES_MATCHING PATTERN "*.hpp"
    PATTERN "gitsha.h"
    PATTERN "pdal/private" EXCLUDE
)
install(DIRECTORY ${PDAL_KERNELS_DIR}
    DESTINATION include/pdal
    FILES_MATCHING PATTERN "*.hpp"
    PATTERN "private" EXCLUDE
)
install(DIRECTORY ${PDAL_IO_DIR}
    DESTINATION include/pdal
    FILES_MATCHING PATTERN "*.hpp"
    PATTERN "private" EXCLUDE
)
install(DIRECTORY ${PDAL_FILTERS_DIR}
    DESTINATION include/pdal
    FILES_MATCHING PATTERN "*.hpp"
    PATTERN "private" EXCLUDE
)

install(FILES ${DIMENSION_OUTFILE} ${pdal_defines_h}
  DESTINATION include/pdal
)

#
# CPACK
#
include (${PDAL_CMAKE_DIR}/cpack.cmake)

add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

export(
    TARGETS
        ${PDAL_BASE_LIB_NAME} ${PDAL_UTIL_LIB_NAME}
    FILE
        "${PDAL_BINARY_DIR}/PDALTargets.cmake")

install(
    EXPORT
        PDALTargets
    DESTINATION
        "${PDAL_LIB_INSTALL_DIR}/pdal/cmake")
include(${PDAL_CMAKE_DIR}/config.cmake)
feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES)
export(PACKAGE PDAL)

# TODO: move under scripts/bash-completion ?
if (WITH_COMPLETION)
    if (IS_DIRECTORY ${CMAKE_INSTALL_PREFIX}/share/bash-completion/completions)
        install(
            FILES
                "${PROJECT_SOURCE_DIR}/scripts/bash-completion/pdal"
            DESTINATION
                "${CMAKE_INSTALL_PREFIX}/share/bash-completion/completions")
    elseif (IS_DIRECTORY /etc/bash_completion.d)
        install(
            FILES
                "${PROJECT_SOURCE_DIR}/scripts/bash-completion/pdal"
            DESTINATION
                "${CMAKE_INSTALL_PREFIX}/etc/bash_completion.d")
    endif()
endif()

=== apps/CMakeLists.txt ===
#
# ./apps CMake configuration file for PDAL utilties
#
# (based originally on the libLAS files copyright Mateusz Loskot)

cmake_minimum_required(VERSION 2.8)

#------------------------------------------------------------------------------
# Configure build targets
#------------------------------------------------------------------------------

set(PDAL_APP pdal)

if (APPLE AND PDAL_BUNDLE)
    add_executable(${PDAL_APP} MACOSX_BUNDLE pdal.cpp)
else (APPLE AND PDAL_BUNDLE)
    add_executable(${PDAL_APP} pdal.cpp)
endif(APPLE AND PDAL_BUNDLE)
target_link_libraries(${PDAL_APP} PRIVATE
    ${PDAL_BASE_LIB_NAME} ${PDAL_UTIL_LIB_NAME})
target_include_directories(${PDAL_APP} PRIVATE
    ${PDAL_JSONCPP_INCLUDE_DIR}
    ${PDAL_INCLUDE_DIR}
    ${PROJECT_BINARY_DIR}/include)

#------------------------------------------------------------------------------
# Targets installation
#------------------------------------------------------------------------------

if (APPLE AND PDAL_BUNDLE)
    install(TARGETS ${PDAL_APP}
        BUNDLE DESTINATION ${PDAL_BIN_INSTALL_DIR})
else(APPLE AND PDAL_BUNDLE)
    install(TARGETS ${PDAL_APP}
        RUNTIME DESTINATION ${PDAL_BIN_INSTALL_DIR})
endif(APPLE AND PDAL_BUNDLE)

set(PKGCONFIG_LIBRARY_DEFINITIONS "")
set(PDAL_INCLUDE_DEFINITIONS
    "-I${CMAKE_INSTALL_PREFIX}/include -I${GDAL_INCLUDE_DIR}")
set(PKGCONFIG_LIBRARY_DEFINITIONS "${PKGCONFIG_LIBRARY_DEFINITIONS} gdal")

if(LIBXML2_FOUND)
    set(PKGCONFIG_LIBRARY_DEFINITIONS
        "${PKGCONFIG_LIBRARY_DEFINITIONS} libxml-2.0")
    set(PDAL_INCLUDE_DEFINITIONS
        "${PDAL_INCLUDE_DEFINITIONS} -I${LIBXML2_INCLUDE_DIR}")
endif()

set(PKGCONFIG_LIBRARY_DEFINITIONS "${PKGCONFIG_LIBRARY_DEFINITIONS} geos")
set(PDAL_INCLUDE_DEFINITIONS
    "${PDAL_INCLUDE_DEFINITIONS} -I${GEOS_INCLUDE_DIR}")

if (LASZIP_FOUND)
    set(PDAL_INCLUDE_DEFINITIONS
        "${PDAL_INCLUDE_DEFINITIONS} -I${LASZIP_INCLUDE_DIR}")
endif()

file(MAKE_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}/pkgconfig/")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/pdal.pc.in
               ${CMAKE_CURRENT_BINARY_DIR}/pdal.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pdal.pc
    DESTINATION "${PDAL_LIB_INSTALL_DIR}/pkgconfig/"
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

if(UNIX OR APPLE)
    # Autoconf compatibility variables to use the same script source.
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/pdal-config.in"
                   "${CMAKE_CURRENT_SOURCE_DIR}/pdal-config" @ONLY)

    file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/pdal-config"
        DESTINATION
            "${PDAL_OUTPUT_BIN_DIR}/"
        FILE_PERMISSIONS
            OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE)

    install(PROGRAMS "${PDAL_OUTPUT_BIN_DIR}/pdal-config"
        DESTINATION
            "${CMAKE_INSTALL_PREFIX}/bin"
        PERMISSIONS
            OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE)

elseif(WIN32)
    # Autoconf compatibility variables to use the same script source.
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/pdal-config-bat.in"
                   "${CMAKE_CURRENT_SOURCE_DIR}/pdal-config.bat" @ONLY)

    file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/pdal-config.bat"
         DESTINATION
            "${PDAL_OUTPUT_BIN_DIR}/"
         FILE_PERMISSIONS
            OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE)

    install(PROGRAMS "${PDAL_OUTPUT_BIN_DIR}/pdal-config.bat"
        DESTINATION
            "${CMAKE_INSTALL_PREFIX}/bin"
        PERMISSIONS
            OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE)

endif()

=== dimbuilder/CMakeLists.txt ===
#
# The seemingly strange arrangement of this cmake file allows you to build
# lasdump as a standalone.
#
cmake_minimum_required(VERSION 2.8.6)

set(MAKE_COLOR_MAKEFILE ON)

if(NOT ROOT_DIR)
    project(DIMBUILDER)
    set(ROOT_DIR "${PROJECT_SOURCE_DIR}/..")
endif()

include(${ROOT_DIR}/cmake/common.cmake NO_POLICY_SCOPE)

#
# We include Utils.cpp here rather than linking in the Utils library because
# some people building linux packages disable rpath, which means that
# the Utils library can't be located when running dimbuilder, even though
# it has been built.
#
add_executable(dimbuilder
    DimBuilder.cpp
    ${PDAL_UTIL_DIR}/Utils.cpp
    ${PDAL_JSONCPP_SRC})
target_include_directories(dimbuilder PRIVATE
    ${PDAL_INCLUDE_DIR}
    ${PDAL_JSONCPP_INCLUDE_DIR})
PDAL_TARGET_COMPILE_SETTINGS(dimbuilder)
if (PDAL_HAVE_JSONCPP)
    target_link_libraries(dimbuilder PRIVATE ${PDAL_JSONCPP_LIB_NAME})
endif()
if (UNIX AND NOT APPLE)
    target_link_libraries(dimbuilder PRIVATE dl)
endif()

=== plugins/CMakeLists.txt ===
include(${PDAL_CMAKE_DIR}/test.cmake)

if(BUILD_PLUGIN_CPD)
    add_subdirectory(cpd)
endif(BUILD_PLUGIN_CPD)

if(BUILD_PLUGIN_GEOWAVE)
    add_subdirectory(geowave)
endif(BUILD_PLUGIN_GEOWAVE)

if(BUILD_PLUGIN_GREYHOUND AND CURL_FOUND)
    add_subdirectory(greyhound)
endif()

if(BUILD_PLUGIN_HEXBIN)
    add_subdirectory(hexbin)
endif()

if(BUILD_PLUGIN_ICEBRIDGE)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build icebridge plugin without libxml2")
    endif()
    add_subdirectory(icebridge)
endif()

if(BUILD_PLUGIN_MATLAB)
    add_subdirectory(matlab)
endif()

if(BUILD_PLUGIN_MBIO)
    add_subdirectory(mbio)
endif()

if(BUILD_PLUGIN_MRSID)
    add_subdirectory(mrsid)
endif()

if(BUILD_PLUGIN_NITF)
    add_subdirectory(nitf)
endif()

if(BUILD_PLUGIN_OCI)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build OCI plugin without libxml2")
    endif()
    add_subdirectory(oci)
endif()

if(BUILD_PLUGIN_PCL)
    add_subdirectory(pcl)
endif()

if(BUILD_PLUGIN_PGPOINTCLOUD)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build pgpointcloud plugin without libxml2")
    endif()
    add_subdirectory(pgpointcloud)
endif()

if(BUILD_PLUGIN_PYTHON)
    add_subdirectory(python)
endif()

if(BUILD_PLUGIN_OPENSCENEGRAPH)
    add_subdirectory(openscenegraph)
endif()

if(BUILD_PLUGIN_RIVLIB)
    add_subdirectory(rxp)
endif(BUILD_PLUGIN_RIVLIB)

if(BUILD_PLUGIN_SQLITE)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build sqlite plugin without libxml2")
    endif()
    add_subdirectory(sqlite)
endif()

=== examples/writing-kernel/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(KernelTutorial)

find_package(PDAL 1.0.0 REQUIRED CONFIG)

set(CMAKE_CXX_FLAGS "-std=c++11")
add_library(pdal_plugin_kernel_mykernel SHARED MyKernel.cpp)
target_link_libraries(pdal_plugin_kernel_mykernel PRIVATE ${PDAL_LIBRARIES})
target_include_directories(pdal_plugin_kernel_mykernel PRIVATE
    ${PDAL_INCLUDE_DIRS}
    /Users/chambbj/loki/pdal/repo/kernels)

=== examples/writing-reader/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(ReaderTutorial)

find_package(PDAL 1.0.0 REQUIRED CONFIG)

set(CMAKE_CXX_FLAGS "-std=c++11")
add_library(pdal_plugin_reader_myreader SHARED MyReader.cpp)
target_link_libraries(pdal_plugin_reader_myreader PRIVATE ${PDAL_LIBRARIES})
target_include_directories(pdal_plugin_reader_myreader PRIVATE
    ${PDAL_INCLUDE_DIRS}
    /Users/chambbj/loki/pdal/repo/readers)

=== examples/writing-writer/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(WriterTutorial)

find_package(PDAL 1.0.0 REQUIRED CONFIG)

set(CMAKE_CXX_FLAGS "-std=c++11")
add_library(pdal_plugin_writer_mywriter SHARED MyWriter.cpp)
target_link_libraries(pdal_plugin_writer_mywriter PRIVATE ${PDAL_LIBRARIES})
target_include_directories(pdal_plugin_writer_mywriter PRIVATE
    ${PDAL_INCLUDE_DIRS})

=== examples/writing/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(WritingTutorial)

find_package(PDAL 1.0.0 REQUIRED CONFIG)

set(CMAKE_CXX_FLAGS "-std=c++11")
add_executable(tutorial tutorial.cpp)
target_link_libraries(tutorial PRIVATE ${PDAL_LIBRARIES})
target_include_directories(tutorial PRIVATE
    ${PDAL_INCLUDE_DIRS}
    ${PDAL_INCLUDE_DIRS}/pdal)

=== pdal/util/CMakeLists.txt ===
#
# Make sure we don't attempt to add a library more than once
#
get_property(EXISTS GLOBAL PROPERTY _UTIL_INCLUDED)
if(EXISTS)
    return()
endif()

set(PDAL_UTIL_SOURCES
    "${PDAL_UTIL_DIR}/Bounds.cpp"
    "${PDAL_UTIL_DIR}/Charbuf.cpp"
    "${PDAL_UTIL_DIR}/FileUtils.cpp"
    "${PDAL_UTIL_DIR}/Georeference.cpp"
    "${PDAL_UTIL_DIR}/Utils.cpp"
    )

PDAL_ADD_FREE_LIBRARY(${PDAL_UTIL_LIB_NAME} SHARED ${PDAL_UTIL_SOURCES})
target_link_libraries(${PDAL_UTIL_LIB_NAME}
    PRIVATE
        ${PDAL_BOOST_LIB_NAME}
)
target_include_directories(${PDAL_UTIL_LIB_NAME} PRIVATE
    ${PDAL_VENDOR_DIR}/pdalboost)

if (UNIX AND NOT APPLE)
    target_link_libraries(${PDAL_UTIL_LIB_NAME}
        PRIVATE
            dl
    )
endif()

set_target_properties(${PDAL_UTIL_LIB_NAME} PROPERTIES
    VERSION "${PDAL_BUILD_VERSION}"
    SOVERSION "${PDAL_API_VERSION}"
    CLEAN_DIRECT_OUTPUT 1)

set_property(GLOBAL PROPERTY _UTIL_INCLUDED TRUE)

=== plugins/cpd/CMakeLists.txt ===
set(Cpd_VERSION 0.5)

find_package(Cpd ${Cpd_VERSION} REQUIRED)
option(BUILD_PLUGIN_CPD "Build Coherent Point Drift support" ${Cpd_FOUND})

set(files filters/CpdFilter.cpp)
set(include_dirs "${CMAKE_CURRENT_LIST_DIR}" "${PDAL_VENDOR_DIR}/eigen")

PDAL_ADD_PLUGIN(filter_libname filter cpd
    FILES filters/CpdFilter.cpp
    LINK_WITH Cpd::Library-C++
    )
target_include_directories(${filter_libname} PRIVATE "${include_dirs}")

if(${WITH_TESTS})
    PDAL_ADD_TEST(pdal_filters_cpd_test
        FILES test/CpdFilterTest.cpp
        LINK_WITH ${filter_libname}
        )
    target_include_directories(pdal_filters_cpd_test PRIVATE "${include_dirs}")
endif()

=== plugins/greyhound/CMakeLists.txt ===
#
# Greyhound plugin CMake configuration
#

add_definitions(-DHAVE_JSONCPP=1)
if (WIN32)
add_definitions("-DARBITER_DLL_IMPORT")
endif()

PDAL_ADD_PLUGIN(libname reader greyhound
    FILES
        io/CompressionStream.cpp
        io/GreyhoundReader.cpp
        io/bounds.cpp
    LINK_WITH ${PDAL_JSONCPP_LIB_NAME})
target_include_directories(${libname} PRIVATE
    ${PDAL_JSONCPP_INCLUDE_DIR}
    ${PDAL_VENDOR_DIR})


if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_io_greyhound_reader_test
        FILES
            test/GreyhoundReaderTest.cpp
        LINK_WITH ${libname} )
target_include_directories(pdal_io_greyhound_reader_test PRIVATE
    ${PDAL_JSONCPP_INCLUDE_DIR}
    ${PDAL_VENDOR_DIR})
endif()

=== plugins/hexbin/CMakeLists.txt ===
#
# HexBin plugin CMake configuration
#

find_package(Hexer REQUIRED)
if (HEXER_FOUND)
    add_definitions(-DHAVE_HEXER=1)

    PDAL_ADD_PLUGIN(libname filter hexbin
        FILES
            filters/HexBin.cpp
        LINK_WITH
            ${HEXER_LIBRARY})
    target_include_directories(${libname} PRIVATE ${PDAL_VENDOR_DIR}/pdalboost)
    target_include_directories(${libname} PUBLIC ${HEXER_INCLUDE_DIR})

    if (WITH_TESTS)
        PDAL_ADD_TEST(hexbintest
            FILES
                test/HexbinFilterTest.cpp
            LINK_WITH
                ${libname})
    endif()


    PDAL_ADD_PLUGIN(density_kernel_libname kernel density
        FILES
            kernel/DensityKernel.cpp
            kernel/OGR.cpp
        LINK_WITH
            ${HEXER_LIBRARY}
            ${libname})

endif()

=== debian/changelog ===
pdal (1.6.0-1build2) bionic; urgency=medium

  * Rebuild against new gdal-abi-2-2-3.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 17 Dec 2017 22:12:49 +0100

pdal (1.6.0-1build1) bionic; urgency=medium

  * No-change rebuild against latest gdal

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sat, 04 Nov 2017 13:09:07 -0400

pdal (1.6.0-1) unstable; urgency=medium

  * Change libhdf5-serial-dev build dependency to libhdf5-dev.
    (closes: #879143)
  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 23 Oct 2017 12:29:51 +0200

pdal (1.6.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update copyright file, changes:
    - Update copyright years for copyright holders
    - Add license & copyright for Java pipeline
    - Add license & copyright for kazhdan
    - Drop license & copyright for rply
  * Rename library packages for SONAME bump.
  * Bump Standards-Version to 4.1.1, no changes.
  * Refresh patches.
  * Drop libpdal-plang package, no longer built.
  * Update files to install in libpdal-plugin-python package.
  * Add lintian override for debian-watch-uses-insecure-uri.
  * Add lintian override for spelling-error-in-binary.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 13 Oct 2017 19:55:04 +0200

pdal (1.5.0-4) unstable; urgency=medium

  * Bump Standards-Version to 4.1.0, no changes.
  * Update privacy-breach.patch to fix privacy-breach-generic issues.
  * Add python3-sphinx to build dependencies.
  * Add patch to fix FTBFS with sphinx >= 1.6.4-1.
    (closes: #877117)
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 29 Sep 2017 11:21:54 +0200

=== debian/control ===
Source: pdal
Section: science
Priority: optional
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Bas Couwenberg <sebastic@debian.org>
Build-Depends: debhelper (>= 9),
               dh-python,
               autotools-dev,
               bash-completion,
               chrpath,
               cmake (>= 3.0),
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libgdal-dev,
               libgeos++-dev,
               libgeotiff-dev,
               libhdf5-dev,
               libjs-mathjax,
               libjsoncpp-dev,
               libpq-dev,
               libproj-dev,
               libspatialite-dev,
               libsqlite3-dev,
               libsqlite3-mod-spatialite,
               libwebsocketpp-dev,
               libxml2-dev,
               pkg-kde-tools,
               python-all-dev,
               python-breathe,
               python-numpy,
               python-sphinx,
               python-sphinx-bootstrap-theme,
               python3-sphinx,
               python3-sphinx-bootstrap-theme,
               rst2pdf,
               zlib1g-dev,
               docbook2x,
               docbook-xsl,
               docbook-xml,
               xsltproc
Standards-Version: 4.1.1
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/pdal.git
Vcs-Git: https://anonscm.debian.org/git/pkg-grass/pdal.git
Homepage: http://pdal.io/

Package: pdal
Architecture: any
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: pdal-doc
Description: Point Data Abstraction Library
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL utilities.

Package: pdal-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${sphinxdoc:Depends},
         ${misc:Depends}
Suggests: libpdal-dev,
          pdal
Description: Point Data Abstraction Library - documentation
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL documentation.

Package: libpdal-base5
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: libpdal-plugins
Description: Point Data Abstraction Library - libpdal_base
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the libpdal_base shared library.

Package: libpdal-util5
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - libpdal_util
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the libpdal_util shared library.

Package: libpdal-dev
Architecture: any
Section: libdevel
Depends: libpdal-base5 (= ${binary:Version}),
         libpdal-util5 (= ${binary:Version}),
         libboost-filesystem-dev,
         libboost-iostreams-dev,
         libboost-program-options-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libgdal-dev,
         libgeos++-dev,
         libgeotiff-dev,
         libproj-dev,
         libxml2-dev,
         ${misc:Depends}
Suggests: pdal-doc
Description: Point Data Abstraction Library - development files
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL development files.

Package: libpdal-plugins
Architecture: any
Section: libs
Depends: libpdal-plugin-greyhound (= ${binary:Version}),
         libpdal-plugin-icebridge (= ${binary:Version}),
         libpdal-plugin-pgpointcloud (= ${binary:Version}),
         libpdal-plugin-python (= ${binary:Version}),
         libpdal-plugin-sqlite (= ${binary:Version}),
         ${misc:Depends}
Description: Point Data Abstraction Library - plugins
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This metapackage depends on the individual PDAL plugin packages.

Package: libpdal-plugin-greyhound
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - Greyhound plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the Greyhound plugin.

Package: libpdal-plugin-icebridge
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - Icebridge plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the Icebridge plugin.

Package: libpdal-plugin-pgpointcloud
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - PostgreSQL PointCloud plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PostgreSQL PointCloud plugin.

Package: libpdal-plugin-python
Architecture: any
Section: libs
Depends: ${python:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - Python plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the Python plugin.

Package: libpdal-plugin-sqlite
Architecture: any
Section: libs
Depends: libsqlite3-mod-spatialite,
         ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - SQLite plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/pkg-info.mk

CXXFLAGS += $(CPPFLAGS)

UPSTREAM_VERSION  = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

BUILD_DATE = $(shell LC_ALL=C date -u "+%d %B %Y" -d "@$(SOURCE_DATE_EPOCH)")

MANPAGES := $(wildcard debian/man/*.*.xml)

%:
	dh $@ --with python2,pkgkde_symbolshelper,sphinxdoc --parallel

override_dh_clean:
	if [ -e debian/gtest.config.guess ]; then \
		mv debian/gtest.config.guess vendor/gtest/build-aux/config.guess ; \
	fi
	if [ -e debian/gtest.config.sub ]; then \
		mv debian/gtest.config.sub   vendor/gtest/build-aux/config.sub ; \
	fi

	dh_clean debian/man/*.1

	$(RM) -r doc/html

override_dh_auto_configure:
	# Don't use outdated autotools helper files
	mv vendor/gtest/build-aux/config.guess debian/gtest.config.guess
	mv vendor/gtest/build-aux/config.sub   debian/gtest.config.sub

	cp /usr/share/misc/config.guess vendor/gtest/build-aux/config.guess
	cp /usr/share/misc/config.sub   vendor/gtest/build-aux/config.sub

	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	                     -DCMAKE_INSTALL_LIBDIR=lib \
	                     -DBUILD_PLUGIN_GREYHOUND=ON \
	                     -DBUILD_PLUGIN_ICEBRIDGE=ON \
	                     -DBUILD_PLUGIN_PYTHON=ON \
	                     -DBUILD_PLUGIN_SQLITE=ON \
	                     -DWITH_COMPLETION=ON

override_dh_auto_build:
	# Create man pages from DocBook XML
	for x in $(MANPAGES) ; do \
	  docbook2x-man --string-param header-3="$(BUILD_DATE)" $$x ; \
	  mv `basename $$x | sed 's/.xml$$//'` `dirname $$x` ; \
	done

	dh_auto_build

	sphinx-build doc/ doc/html/ && ln -s /usr/share/javascript/mathjax doc/html/_static/

override_dh_auto_test:
	# Exclude tests:
	# - pgpointcloudtest, requires configured PostgreSQL database
	# - pdal_spatial_reference_test, fails sometimes
	(cd obj-* && ctest --force-new-ctest-process --output-on-failure --exclude-regex "pgpointcloudtest|pdal_spatial_reference_test" || echo "Ignoring test failures")

override_dh_auto_install:
	dh_auto_install

	# Strip RPATH
	chrpath --delete debian/tmp/usr/lib/libpdal_plugin_*.so

override_dh_install:
	dh_install --list-missing

override_dh_python2:
	dh_python2 -plibpdal-plugin-python
	dh_numpy -plibpdal-plugin-python

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(UPSTREAM_VERSION) -c0

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/ \
http://download.osgeo.org/pdal/ \
(?:.*?/)?(?:rel|v|PDAL)?[\-\_]?(\d\S+?)(?:-src)?\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
